/*
 * tool_text
 *
 * delete_crlf.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "..\CLCLPlugin.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern HINSTANCE hInst;
extern TCHAR ini_path[];

extern int delete_crlf_delete_space;

/* Local Function Prototypes */

/*
 * item_delete_crlf - s̏
 */
static int item_delete_crlf(DATA_INFO *di)
{
	HANDLE ret;
	BYTE *from_mem, *to_mem;
	char *p, *r;
	int size;

	// Rs[bN
	if ((from_mem = GlobalLock(di->data)) == NULL) {
		return TOOL_ERROR;
	}

	// sTCY擾
	size = 0;
	p = from_mem;
	if (delete_crlf_delete_space == 1) {
		for (; *p == ' ' || *p == '\t'; p++)
			;
	}
	while (*p != '\0') {
		if (IsDBCSLeadByte((BYTE)*p) == TRUE) {
			p += 2;
			size += 2;
			continue;
		}
		if (*p == '\r' || *p == '\n') {
			for (; *p == '\r' || *p == '\n'; p++)
				;
			if (delete_crlf_delete_space == 1) {
				for (; *p == ' ' || *p == '\t'; p++)
					;
			}
		} else {
			p++;
			size++;
		}
	}
	size++;

	// Rs[m
	if ((ret = GlobalAlloc(GHND, size)) == NULL) {
		GlobalUnlock(di->data);
		return TOOL_ERROR;
	}
	// Rs[惍bN
	if ((to_mem = GlobalLock(ret)) == NULL) {
		GlobalFree(ret);
		GlobalUnlock(di->data);
		return TOOL_ERROR;
	}

	// s̏
	p = from_mem;
	r = to_mem;
	if (delete_crlf_delete_space == 1) {
		for (; *p == ' ' || *p == '\t'; p++)
			;
	}
	while (*p != '\0') {
		if (IsDBCSLeadByte((BYTE)*p) == TRUE) {
			*(r++) = *(p++);
			*(r++) = *(p++);
			continue;
		}
		if (*p == '\r' || *p == '\n') {
			for (; *p == '\r' || *p == '\n'; p++)
				;
			if (delete_crlf_delete_space == 1) {
				for (; *p == ' ' || *p == '\t'; p++)
					;
			}
		} else {
			*(r++) = *(p++);
		}
	}
	*r = '\0';

	GlobalUnlock(ret);
	GlobalUnlock(di->data);

	GlobalFree(di->data);
	di->data = ret;
	di->size = size;
	return TOOL_DATA_MODIFIED;
}

/*
 * delete_crlf - s̏
 */
__declspec(dllexport) int CALLBACK delete_crlf(const HWND hWnd, TOOL_EXEC_INFO *tei, TOOL_DATA_INFO *tdi)
{
	DATA_INFO *di;
	int ret = TOOL_SUCCEED;

	for (; tdi != NULL; tdi = tdi->next) {
		di = (DATA_INFO *)SendMessage(hWnd, WM_ITEM_GET_FORMAT_TO_ITEM, (WPARAM)TEXT("TEXT"), (LPARAM)tdi->di);
		if (di != NULL && di->data != NULL) {
			ret |= item_delete_crlf(di);
		}
	}
	return ret;
}

/*
 * set_delete_crlf_proc - ݒ
 */
BOOL CALLBACK set_delete_crlf_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	TCHAR buf[BUF_SIZE];

	switch (uMsg) {
	case WM_INITDIALOG:
		CheckDlgButton(hDlg, IDC_CHECK_DELETE_SPACE, delete_crlf_delete_space);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			delete_crlf_delete_space = IsDlgButtonChecked(hDlg, IDC_CHECK_DELETE_SPACE);

			wsprintf(buf, TEXT("%d"), delete_crlf_delete_space);
			WritePrivateProfileString(TEXT("delete_crlf"), TEXT("delete_space"), buf, ini_path);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * delete_crlf_property - vpeB\
 */
__declspec(dllexport) BOOL CALLBACK delete_crlf_property(const HWND hWnd, TOOL_EXEC_INFO *tei)
{
	DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_DELETE_CRLF), hWnd, set_delete_crlf_proc, 0);
	return TRUE;
}
/* End of source */
